unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Mask, Vcl.ComCtrls,
  Vcl.ExtCtrls, UnitDllDefs, Vcl.Menus;

type
  Tfmmain = class(TForm)
    StatusBar: TStatusBar;
    PageControl1: TPageControl;
    TSI2C: TTabSheet;
    Panel2: TPanel;
    PageControl2: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    btn_i2c_write: TButton;
    btn_i2c_read: TButton;
    EditRCnt: TEdit;
    EditWrite: TEdit;
    UpDown1: TUpDown;
    GroupBox1: TGroupBox;
    btn_set_irq: TButton;
    rb_irq0: TRadioButton;
    rb_irq1: TRadioButton;
    rb_irq2: TRadioButton;
    btn_get_irq: TButton;
    GroupBox2: TGroupBox;
    lb_scl: TLabel;
    btn_set_scl: TButton;
    ed_scl: TEdit;
    btn_get_scl: TButton;
    cb_scl_unit: TComboBox;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    LbChkSlv: TLabel;
    EditSlvAddr: TEdit;
    btn_i2c_scan: TButton;
    btn_check_slave: TButton;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    lb_i2c_slvadr: TLabel;
    ed_hw_slvaddr: TEdit;
    btn_set_hw_slvaddr: TButton;
    btn_write_slvbuf: TButton;
    ed_slave_data: TEdit;
    cb_int_out: TCheckBox;
    TabSheet3: TTabSheet;
    Panel5: TPanel;
    btn_set_gar: TButton;
    btn_set_subr: TButton;
    btn_set_shar: TButton;
    btn_set_ip: TButton;
    ed_gar: TMaskEdit;
    ed_subr: TMaskEdit;
    ed_shar: TMaskEdit;
    ed_ip: TMaskEdit;
    btn_set_tcpport: TButton;
    ed_tcpport: TEdit;
    btn_reinit: TButton;
    btn_set_udpport: TButton;
    ed_udpport: TEdit;
    btn_loadfactory: TButton;
    GroupBox6: TGroupBox;
    btn_setprotect: TButton;
    btn_getprotect: TButton;
    cm_mem_protected: TCheckBox;
    GroupBox8: TGroupBox;
    Label19: TLabel;
    Label20: TLabel;
    Label4: TLabel;
    btn_setkpalive: TButton;
    ed_kpalive: TEdit;
    ed_phycheck: TEdit;
    btn_setphycheck: TButton;
    btn_setvmkpalive: TButton;
    ed_vmkpalive: TEdit;
    btn_set_vmtcpport: TButton;
    ed_vmtcpport: TEdit;
    btn_set_vmudpport: TButton;
    ed_vmudpport: TEdit;
    TabSheet4: TTabSheet;
    lb_vmstate: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    btn_vmstart: TButton;
    btn_vmstop: TButton;
    btn_get_vmstate: TButton;
    ed_vmirq: TEdit;
    btn_vmirq: TButton;
    Button1: TButton;
    btn_vmflash: TButton;
    btn_LoadToEEP: TButton;
    btn_LoadFromEEP: TButton;
    ed_flashaddr: TEdit;
    ed_pagesize: TEdit;
    btn_SaveParam: TButton;
    btn_GetParam: TButton;
    ed_eepflashaddr: TEdit;
    cb_loadvm: TCheckBox;
    cb_runvm: TCheckBox;
    btn_irqresult: TButton;
    Panel4: TPanel;
    btn_set_mode: TButton;
    rb_master: TRadioButton;
    rb_slave: TRadioButton;
    rb_read_mode: TRadioButton;
    ed_hw_slaveaddr: TEdit;
    rb_prog: TRadioButton;
    btn_savesettings: TButton;
    btn_resetsettings: TButton;
    btn_get_version: TButton;
    TSNet: TTabSheet;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    ed_server_port: TEdit;
    BtnSetServerValues: TButton;
    ed_server_ip: TMaskEdit;
    GroupBox5: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    lbgar: TLabel;
    lbsubr: TLabel;
    lbshar: TLabel;
    lbip: TLabel;
    lbtcpport: TLabel;
    lbudpport: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    lbkpalive: TLabel;
    lbphycheck: TLabel;
    Label5: TLabel;
    lbvmkpalive: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    lbvmtcpport: TLabel;
    lbvmudpport: TLabel;
    btn_read_settings: TButton;
    TSMemory: TTabSheet;
    Panel6: TPanel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    btnrdbyte: TButton;
    edrdaddr: TEdit;
    btnrdword: TButton;
    btnrddword: TButton;
    btnrdblock: TButton;
    btnwrbyte: TButton;
    edwraddr: TEdit;
    btnwrword: TButton;
    btnwrdword: TButton;
    btnwrblock: TButton;
    edwrbyte: TEdit;
    edwrword: TEdit;
    edwrdword: TEdit;
    edwrblock: TEdit;
    edrdblocklen: TEdit;
    UpDown2: TUpDown;
    Memo: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    ClearMemo1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog2: TOpenDialog;
    btn_vmreset: TButton;
    btn_codeloaded: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Connect1Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure ClearMemo1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure btn_set_modeClick(Sender: TObject);
    procedure btn_savesettingsClick(Sender: TObject);
    procedure btn_resetsettingsClick(Sender: TObject);
    procedure btn_get_versionClick(Sender: TObject);
    procedure btn_i2c_writeClick(Sender: TObject);
    procedure btn_i2c_readClick(Sender: TObject);
    procedure btn_check_slaveClick(Sender: TObject);
    procedure btn_i2c_scanClick(Sender: TObject);
    procedure btn_set_sclClick(Sender: TObject);
    procedure btn_get_sclClick(Sender: TObject);
    procedure btn_set_irqClick(Sender: TObject);
    procedure btn_get_irqClick(Sender: TObject);
    procedure btn_set_hw_slvaddrClick(Sender: TObject);
    procedure btn_write_slvbufClick(Sender: TObject);
    procedure btn_set_garClick(Sender: TObject);
    procedure btn_set_subrClick(Sender: TObject);
    procedure btn_set_sharClick(Sender: TObject);
    procedure btn_set_ipClick(Sender: TObject);
    procedure btn_set_tcpportClick(Sender: TObject);
    procedure btn_set_udpportClick(Sender: TObject);
    procedure btn_set_vmtcpportClick(Sender: TObject);
    procedure btn_set_vmudpportClick(Sender: TObject);
    procedure btn_reinitClick(Sender: TObject);
    procedure btn_loadfactoryClick(Sender: TObject);
    procedure btn_setprotectClick(Sender: TObject);
    procedure btn_getprotectClick(Sender: TObject);
    procedure btn_setkpaliveClick(Sender: TObject);
    procedure btn_setvmkpaliveClick(Sender: TObject);
    procedure btn_setphycheckClick(Sender: TObject);
    procedure btn_vmstartClick(Sender: TObject);
    procedure btn_vmstopClick(Sender: TObject);
    procedure btn_get_vmstateClick(Sender: TObject);
    procedure btn_vmirqClick(Sender: TObject);
    procedure btn_irqresultClick(Sender: TObject);
    procedure btn_vmflashClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btn_LoadToEEPClick(Sender: TObject);
    procedure btn_LoadFromEEPClick(Sender: TObject);
    procedure btn_SaveParamClick(Sender: TObject);
    procedure btn_GetParamClick(Sender: TObject);
    procedure BtnSetServerValuesClick(Sender: TObject);
    procedure btn_read_settingsClick(Sender: TObject);
    procedure btnwrbyteClick(Sender: TObject);
    procedure btnrdbyteClick(Sender: TObject);
    procedure btn_vmresetClick(Sender: TObject);
    procedure btn_codeloadedClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure tomemo(stxt : String; lastline : Boolean = false);
    procedure memoclear;
    function DWORDTosIP(dwIP: DWORD): String;
    function GetIPBytes(sIP : String; iPosi : Byte) : Byte;
  end;

  procedure IRQEvent; stdcall;
  procedure SlaveEvent(const slvdata : Pointer; wSize : word); stdcall;
  procedure VM8051Event(const vmdata : Pointer; wSize : word); stdcall;
  procedure VMFlashCallBack(fl0, fl : Word; dwErr :DWORD); stdcall;

var
  fmmain: Tfmmain;
  sServer  : String;
  wTCPPort : Word;

implementation

{$R *.dfm}

procedure IRQEvent;
begin
  fmMain.Memo.Lines.Add('INTERRUPT');
end;

procedure SlaveEvent(const slvdata : Pointer; wSize : word);
var i : word;
    stri : string;
begin
  stri := '';
  for i := 0 to wSize - 1 do
  begin
    Stri := Stri + Format('%.2x ', [Cardinal(PAnsiChar(slvdata)[I])]);
  end;
  fmMain.memo.lines.add('SLAVE RX:');
  fmMain.memo.lines.add(stri);
end;

procedure VM8051Event(const vmdata : Pointer; wSize : word);
var i : word;
    stri : string;
begin
  stri := '';
  for i := 0 to wSize - 1 do
  begin
    Stri := Stri + Format('%.2x ', [Cardinal(PAnsiChar(vmdata)[I])]);
  end;
  fmMain.memo.lines.add('VM RX:');
  fmMain.memo.lines.add(stri);
end;

procedure VMFlashCallBack(fl0, fl : Word; dwErr :DWORD); stdcall;
var procent : integer;
begin
  procent := round(((fl0 - fl) / fl0) * 100);
  fmmain.tomemo('uploading: '+IntToStr(procent)+'%',true);
end;

procedure Tfmmain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if connected = RET_OK then
  begin
    disconnect;
  end;
end;

procedure Tfmmain.FormCreate(Sender: TObject);
begin
  cb_scl_unit.ItemIndex := 1;
  initnetiic(@IRQEvent,@SlaveEvent,@VM8051Event);
  sServer  := '192.168.1.100';
  wTCPPort := 5000;
end;

procedure TfmMain.memoclear;
begin
  memo.Lines.Clear;
end;

procedure TfmMain.tomemo(stxt: String; lastline : Boolean);
begin
  if (lastline) and (Memo.Lines.Count > 0) then
  begin
    Memo.Lines.Strings[Memo.Lines.Count-1] := stxt;
  end else
  begin
    Memo.Lines.Add(stxt);
  end;
end;

procedure Tfmmain.btnrdbyteClick(Sender: TObject);
var tmp_addr  : WORD;
    wSize, i  : WORD;
    tmp_byte  : Byte;
    tmp_word  : WORD;
    tmp_dword : DWORD;
    tmp_data  : array of Byte;
    dwErr     : DWORD;
    stxt      : String;
begin
  tmp_addr := StrToInt('$'+edrdaddr.Text);
  case (Sender As TButton).Tag of
  CMD_RDBYTE :
    begin
      dwErr := memrd8bit(tmp_addr,tmp_byte,1000);
      if dwErr = RET_OK then
        Memo.Lines.Add('READ BYTE: 0x'+IntToHex(tmp_byte,2));
      statusbar.panels[0].text := 'MEM RD BYTE: '+ GetErrorString(dwErr);
    end;
  CMD_RDWORD:
    begin
      dwErr := memrd16bit(tmp_addr,tmp_word,1000);
      Memo.Lines.Add('READ WORD: 0x'+IntToHex(tmp_word,4));
      statusbar.panels[0].text := 'MEM RD WORD: '+ GetErrorString(dwErr);
    end;
  CMD_RDDWORD:
     begin
       dwErr := memrd32bit(tmp_addr,tmp_dword,1000);
       Memo.Lines.Add('READ DWORD: 0x'+IntToHex(tmp_dword,8));
       statusbar.panels[0].text := 'MEM RD DWORD: '+ GetErrorString(dwErr);
     end;
  CMD_RDBLOCK:
     begin
       wSize := StrToIntDef(edrdblocklen.Text,0);
       setlength(tmp_data,wSize);
       dwErr := memrdblock(tmp_addr,tmp_data[0],wSize,2000);
       if dwErr = RET_OK then
       begin
         Memo.Lines.Add(IntToStr(wSize)+' Byte(s) read:');
         if wSize > 0 then
         begin
           stxt := '';
           for i := 0 to wSize - 1 do
             stxt := stxt + '['+IntToHex(tmp_data[i],2)+'] ';
           Memo.Lines.Add(stxt);
         end;
       end;
       statusbar.panels[0].text := 'MEM RD BLOCK: '+ GetErrorString(dwErr);
     end;
  end;
end;

procedure Tfmmain.BtnSetServerValuesClick(Sender: TObject);
var stri : string;
begin
  if connected <> RET_OK then
  begin
    stri := ed_server_ip.Text;
    while (pos(' ',stri) > 0) do delete(stri,pos(' ',stri),1);
    sServer := stri;
    wTCPPort := StrToIntDef(ed_server_port.Text,5000);
  end else showmessage('Client ist Connected');
end;

procedure Tfmmain.btnwrbyteClick(Sender: TObject);
var tmp_addr  : WORD;
    tmp_byte  : BYTE;
    tmp_word  : WORD;
    tmp_dword : DWORD;
    tmp_data  : array of byte;
    tmp_sdata : string;
    wSize, i  : WORD;
    dwErr     : DWORD;
begin
  tmp_addr := StrToInt('$'+edwraddr.Text);
  case (Sender As TButton).Tag of
  CMD_WRBYTE:
     begin
       tmp_byte := StrToInt('$'+edwrbyte.Text);
       dwErr := memwr8bit(tmp_addr,tmp_byte,1000);
       statusbar.panels[0].text := 'MEM WR BYTE: '+ GetErrorString(dwErr);
     end;
  CMD_WRWORD:
     begin
       tmp_word := StrToInt('$'+edwrword.Text);
       dwErr := memwr16bit(tmp_addr,tmp_word,1000);
       statusbar.panels[0].text := 'MEM WR WORD: '+ GetErrorString(dwErr);
     end;
  CMD_WRDWORD:
     begin
       tmp_dword := StrToInt('$'+edwrdword.Text);
       dwErr := memwr32bit(tmp_addr,tmp_dword,1000);
       statusbar.panels[0].text := 'MEM WR DWORD: '+ GetErrorString(dwErr);
     end;
  CMD_WRBLOCK:
     begin
       tmp_sdata := edwrblock.Text;
       wSize := length(tmp_sdata) DIV 2;
       setlength(tmp_data,wSize);
       for i := 0 to wSize -1 do
       begin
         tmp_data[i] := StrToInt('$'+copy(tmp_sdata,1,2));
         delete(tmp_sdata,1,2);
       end;
       dwErr := memwrblock(tmp_addr,tmp_data[0],wSize,2000);
       statusbar.panels[0].text := 'MEM WR BLOCK: '+ GetErrorString(dwErr);
     end;
  end;
end;

procedure Tfmmain.btn_check_slaveClick(Sender: TObject);
var ucslvaddr, ucConnected : byte;
    dwErr : DWORD;
begin
  ucslvaddr := StrToIntDef('$'+EditSlvAddr.Text,$FE);
  EditSlvAddr.Text := IntToHex(ucslvaddr,2);

  dwErr := chkslvaddr(ucslvaddr, ucConnected, 1000);
  if dwErr = RET_OK then
  begin
    if ucConnected = 1 then
       lbchkslv.caption := 'OK'
    else lbchkslv.caption := 'BAD';
  end;
  StatusBar.Panels[0].text := 'CHECK SLAVE ADDR: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_codeloadedClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := vmcodeloaded(1000);
  if dwErr = RET_OK then
    Memo.Lines.Add('VM CODE is loaded');
  statusbar.panels[0].text := 'VM CODE LOADED: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_GetParamClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
    ucLoad : Byte;
begin
  ucLoad := Byte(cb_runvm.Checked);
  ucLoad := ucLoad shl 1;
  ucLoad := ucLoad or Byte(cb_loadvm.Checked);

  dwErr := vmgetparam(ucLoad, wAddr ,1000);
  if dwErr = RET_OK then
  begin
    ed_eepflashaddr.Text := IntToHex(wAddr,4);
    cb_loadvm.Checked := ((ucLoad and $01) = $01);
    cb_runvm.Checked := ((ucLoad and $02) = $02);
  end;
  statusbar.panels[0].text := 'SAVE VM PARAM: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_getprotectClick(Sender: TObject);
var dwErr : DWORD;
    mem_protected : byte;
begin
  mem_protected := 0;
  dwErr := getmemprotect(mem_protected,1000);
  if dwErr = RET_OK then
  begin
    cm_mem_protected.Checked := Boolean(mem_protected and 1);
  end;
  statusbar.panels[0].text := 'MEM PROTECT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_get_irqClick(Sender: TObject);
const ResIRQ : array[0..2] of string = ('DISABLE','FALLING EDGE','RISING EDGE');
var dwErr : DWORD;
    ucMode : Byte;
begin
  dwErr := GetIRQ(ucMode,1000);
  if dwErr = RET_OK then
  begin
    case ucMode of
      0 : rb_irq0.Checked := true;
      1 : rb_irq1.Checked := true;
      2 : rb_irq2.Checked := true;
      else rb_irq0.Checked := true;
    end;
  end;
  StatusBar.Panels[0].text := 'GetIRQ: '+ GetErrorString(dwErr) +' - '+ ResIRQ[ucMode];
end;

procedure Tfmmain.btn_get_sclClick(Sender: TObject);
var dwfreq : dword;
    dwErr : DWORD;
begin
  dwErr := GetSCL(dwfreq,1000);
  if dwErr = RET_OK then
  begin
    if dwfreq >= 10000 then
      lb_scl.Caption := IntToStr(Round(dwfreq / 1000))+ ' kHz'
    else if dwfreq >= 1000 then
      lb_scl.Caption := Format('%f kHz',[dwfreq / 1000])
    else lb_scl.Caption := IntToStr(dwfreq)+' Hz';
  end else lb_scl.Caption := '--- kHz';
  StatusBar.Panels[0].text := 'GET SCL: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_get_versionClick(Sender: TObject);
var version : Word;
    dwErr : DWORD;
begin
  dwErr := getversion(version,1000);
  if dwErr = RET_OK then
  Memo.Lines.Add('Version: '+IntToHex(version,4));

  statusbar.panels[0].text := 'GET VERSION: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_get_vmstateClick(Sender: TObject);
var dwErr : DWORD;
    isrunning : Byte;
begin
  dwErr := vmgetstate(isrunning,1000);
  case isrunning of
  0 : lb_vmstate.Caption := 'ABORTED';
  1 : lb_vmstate.Caption := 'RUNNING';
  2 : lb_vmstate.Caption := 'ABORT REQUESTED';
  3 : lb_vmstate.Caption := 'START REQUESTED';
  else lb_vmstate.Caption := 'VM STATE UNKNOWN';
  end;
  statusbar.panels[0].text := 'VM STATE: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_i2c_readClick(Sender: TObject);
var wSize, i : WORD;
    stxt : String;
    dwErr  : DWORD;
    buf    : Array of Byte;
    ucSlv  : Byte;
begin
  ucSlv := StrToIntDef('$'+editslvaddr.Text,$40);
  wSize := StrToIntDef(editRCnt.Text,1);
  editRCnt.Text := IntToStr(wSize);
  setlength(buf,wSize);
  dwErr := ReadI2C(ucSlv,buf[0],wSize,1000);
  if dwErr = RET_OK then
  begin
    Memo.Lines.Add(IntToStr(wSize)+' Byte(s) read:');
    if wSize > 0 then
    begin
      stxt := '';
      for i := 0 to wSize - 1 do
        stxt := stxt + '['+IntToHex(buf[i],2)+'] ';
      Memo.Lines.Add(stxt);
    end;
  end;
  StatusBar.Panels[0].text := 'READ I2C: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_i2c_scanClick(Sender: TObject);
var dwErr : DWORD;
    buf : Array of Byte;
    ucSize, i : Byte;
    stxt : String;
begin
  Setlength(buf,128);
  dwErr := ScanI2C(buf[0],ucSize,5000);
  if (dwErr = RET_OK) then
  begin
    if (ucSize > 0) then
    begin
      Memo.Lines.Add(IntToStr(ucSize)+' Device(s) found:');
      stxt := '';
      for i := 0 to ucSize - 1 do
        stxt := stxt + '['+IntToHex(buf[i],2)+'] ';
      Memo.Lines.Add(stxt);
    end else Memo.Lines.Add('NO DEVICES FOUND');
  end;
  StatusBar.Panels[0].text := 'SCAN I2C: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_i2c_writeClick(Sender: TObject);
var wSize, i : WORD;
    si2cdata : String;
    i2cdata : Array of Byte;
    dwErr   : DWORD;
    ucSlv   : Byte;
begin
  ucSlv := StrToIntDef('$'+editslvaddr.Text,$40);
  si2cdata := EditWrite.Text;
  wSize := length(si2cdata) DIV 2;
  setlength(i2cdata,wSize);

  for i := 0 to wSize -1 do
  begin
    i2cdata[i] := StrToInt('$'+copy(si2cdata,1,2));
    delete(si2cdata,1,2);
  end;
  dwErr := WriteI2C(ucSlv,i2cdata[0],wSize,1000);
  if dwErr = RET_OK then Memo.Lines.Add(IntToStr(wSize)+' Byte(s) written');
  StatusBar.Panels[0].text := 'WRITE I2C: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_irqresultClick(Sender: TObject);
var dwErr : DWORD;
    irqresult : Byte;
begin
  dwErr := vmirqresult(irqresult,1000);
  if dwerr = RET_OK then
  begin
    case irqresult of
    0 : Memo.Lines.Add('IRQ Request pending or error');
    1 : Memo.Lines.Add('IRQ Data received by VM successfully');
    else lb_vmstate.Caption := 'VM IRQ RESULT UNKNOWN';
    end;
  end else statusbar.panels[0].text := 'VM IRQ RESULT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_loadfactoryClick(Sender: TObject);
begin
  statusbar.panels[0].text := 'LOAD FACTORY SETTINGS...: '+ GetErrorString(loadfactoryconfig(1000));
end;

procedure Tfmmain.btn_LoadFromEEPClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
begin
  wAddr := StrToIntDef('$'+ed_flashaddr.Text,$0100);
  ed_flashaddr.Text := IntToHex(wAddr,4);
  dwErr := vmloadfromeep(wAddr ,1000);
  statusbar.panels[0].text := 'LOAD VM IMAGE FROM EEP: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_LoadToEEPClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
    ucPageSize : Byte;
begin
  wAddr := StrToIntDef('$'+ed_flashaddr.Text,$0100);
  ucPageSize := StrToIntDef(ed_pagesize.Text,32);
  ed_flashaddr.Text := IntToHex(wAddr,4);
  ed_pagesize.Text := IntToStr(ucPageSize);

  if OpenDialog2.Execute then
  begin
    memoclear;
    tomemo('Select Image File:');
    tomemo(OpenDialog2.FileName);
    tomemo('Start flashing image (EEPROM):');
    tomemo('uploading: 0%');
    dwErr := vmloadtoeep_w(PChar(OpenDialog2.FileName),wAddr, ucPageSize, @VMFlashCallBack,1000);
    if dwErr = RET_OK then
      tomemo('Uploading binary file OK')
    else tomemo('Uploading binary file failed');

    statusbar.panels[0].text := 'VM IMAGE TO EEP: '+ GetErrorString(dwErr);
  end;
end;

procedure Tfmmain.btn_read_settingsClick(Sender: TObject);
var dwErr : DWORD;
    pBuf  : array[0..28] of byte;
    pnetconfig : PTNetConfig;
    stri : string;
begin
  dwErr := getnetconfig(pBuf,1000);
  if dwErr = RET_OK then
  begin
    pnetconfig := @pBuf;

    stri := IntToHex(pnetconfig.SHAR[0],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[1],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[2],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[3],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[4],2)+'-';
    stri := stri + IntToHex(pnetconfig.SHAR[5],2);
    lbshar.caption := stri;

    lbgar.Caption := DWORDTosIP(pnetconfig.GAR);
    lbsubr.Caption := DWORDTosIP(pnetconfig.SUBR);
    lbip.Caption := DWORDTosIP(pnetconfig.ip);

    lbtcpport.caption := IntToStr(pnetconfig.TCPPORT);
    lbudpport.caption := IntToStr(pnetconfig.UDPPORT);
    lbvmtcpport.caption := IntToStr(pnetconfig.VMTCPPORT);
    lbvmudpport.caption := IntToStr(pnetconfig.VMUDPPORT);

    lbkpalive.caption := IntToStr(pnetconfig.KPALIVE * 5);
    lbvmkpalive.caption := IntToStr(pnetconfig.VMKPALIVE * 5);
    lbphycheck.caption := IntToStr(pnetconfig.PHYCHECK * 5);
  end;
  statusbar.panels[0].text := 'GET CONFIG: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_reinitClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := reinit(1000);
  statusbar.panels[0].text := 'REINIT...: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_resetsettingsClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := resetsettings(1000);
  statusbar.panels[0].text := 'Reset Settings: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_SaveParamClick(Sender: TObject);
var dwErr : DWORD;
    wAddr : WORD;
    ucLoad : Byte;
begin
  wAddr := StrToIntDef('$'+ed_eepflashaddr.Text,$0100);
  ed_eepflashaddr.Text := IntToHex(wAddr,4);

  ucLoad := Byte(cb_runvm.Checked);
  ucLoad := ucLoad shl 1;
  ucLoad := ucLoad or Byte(cb_loadvm.Checked);

  dwErr := vmsetparam(ucLoad, wAddr ,1000);
  statusbar.panels[0].text := 'SAVE VM PARAM: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_savesettingsClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := savesettings(1000);
  statusbar.panels[0].text := 'Save Settings: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_setkpaliveClick(Sender: TObject);
var dwErr : DWORD;
    kpalive : Byte;
begin
  kpalive := StrToIntDef(ed_kpalive.Text,600) DIV 5;
  ed_kpalive.Text := IntToStr(kpalive * 5);
  dwErr := setkeepalive(kpalive,1000);
  statusbar.panels[0].text := 'SET KEEPALIVE: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_setphycheckClick(Sender: TObject);
var dwErr : DWORD;
    phycheck : Byte;
begin
  phycheck := StrToIntDef(ed_phycheck.Text,60) DIV 5;
  ed_phycheck.Text := IntToStr(phycheck * 5);

  dwErr := setphycheck(phycheck,1000);
  statusbar.panels[0].text := 'SET PHYCHECK: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_setprotectClick(Sender: TObject);
var dwErr : DWORD;
begin
  dwErr := setmemprotect(Byte(cm_mem_protected.Checked),1000);
  statusbar.panels[0].text := 'MEM PROTECT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_setvmkpaliveClick(Sender: TObject);
var dwErr : DWORD;
    vmkpalive : Byte;
begin
  vmkpalive := StrToIntDef(ed_vmkpalive.Text,600) DIV 5;
  ed_vmkpalive.Text := IntToStr(vmkpalive * 5);
  dwErr := setvmkeepalive(vmkpalive,1000);
  statusbar.panels[0].text := 'SET VM KEEPALIVE: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_garClick(Sender: TObject);
var sTmp : String;
    dwErr : DWORD;
begin
  sTmp := ed_gar.Text;
  dwErr := setgar(GetIPBytes(sTmp,1),
                  GetIPBytes(sTmp,2),
                  GetIPBytes(sTmp,3),
                  GetIPBytes(sTmp,4),1000);
  statusbar.panels[0].text := 'SET GAR: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_hw_slvaddrClick(Sender: TObject);
var ucslvaddr : byte;
    dwErr : DWORD;
begin
  ucslvaddr := StrToIntDef('$'+ed_hw_slvaddr.Text,$FE) and $FE;
  dwErr := seti2cslvaddr(ucslvaddr,1000);
   if dwErr = RET_OK then
   begin
     lb_i2c_slvadr.Caption := '0x'+IntToHex(ucslvaddr AND $FE,2);
     ed_hw_slvaddr.Text := IntToHex(ucslvaddr AND $FE,2);
   end;
  StatusBar.Panels[0].text := 'SET SLAVE ADDR: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_ipClick(Sender: TObject);
var sTmp : String;
    dwErr : DWORD;
begin
  sTmp := ed_ip.Text;
  dwErr := setip(GetIPBytes(sTmp,1),
                 GetIPBytes(sTmp,2),
                 GetIPBytes(sTmp,3),
                 GetIPBytes(sTmp,4),1000);
  statusbar.panels[0].text := 'SET IP: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_irqClick(Sender: TObject);
const ResIRQ : array[0..2] of string = ('DISABLE','FALLING EDGE','RISING EDGE');
var dwErr : DWORD;
    ucMode : Byte;
begin
  if rb_irq0.Checked then ucMode := 0 else //disable interrupt
  if rb_irq1.Checked then ucMode := 1 else //enable interrupt; falling-edge
  ucMode := 2;                            //enable interrupt; rising-edge

  dwErr := SetIRQ(ucMode,1000);
  if dwErr = RET_OK then
  begin
    case ucMode of
      0 : rb_irq0.Checked := true;
      1 : rb_irq1.Checked := true;
      2 : rb_irq2.Checked := true;
      else rb_irq0.Checked := true;
    end;
  end;
  StatusBar.Panels[0].text := 'SetIRQ: '+ GetErrorString(dwErr) +' - '+ ResIRQ[ucMode];
end;

procedure Tfmmain.btn_set_modeClick(Sender: TObject);
var ucmode, ucslvadr : byte;
    dwErr : DWORD;
begin
  if rb_master.Checked then
    ucMode := 1  // Master mode
  else if rb_slave.checked then
    ucMode := 2 // Slave mode
  else if rb_prog.Checked then
    ucMode := 3
  else ucMode := 0;  // read settings

  ucSlvAdr := StrToIntDef('$'+ed_hw_slaveaddr.Text,$FE) and $FE;
  dwErr := setmode(ucmode,ucslvadr,1000);
  if dwErr = RET_OK then
  begin
    lb_i2c_slvadr.Caption := '0x'+IntToHex(ucSlvAdr AND $FE,2);
    ed_hw_slvaddr.Text := IntToHex(ucSlvAdr AND $FE,2);
    ed_hw_slaveaddr.Text := IntToHex(ucSlvAdr AND $FE,2);
    rb_master.Checked := (ucMode = 1);
    rb_slave.Checked  := (ucMode = 2);
    rb_prog.Checked   := (ucMode = 3);

    PageControl2.ActivePageIndex := ucMode - 1;
  end;
  StatusBar.Panels[0].text := 'SET MODE: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_sclClick(Sender: TObject);
var dwfreq : dword;
    dwErr : DWORD;
begin
  dwfreq := StrToIntDef(ed_scl.Text,100);
  if cb_scl_unit.ItemIndex = 1 then dwfreq := dwfreq * 1000;
  dwErr := SetSCL(dwfreq,1000);
  if dwErr = RET_OK then
  begin
    if dwfreq >= 10000 then
      lb_scl.Caption := IntToStr(Round(dwfreq / 1000))+ ' kHz'
    else if dwfreq >= 1000 then
      lb_scl.Caption := Format('%f kHz',[dwfreq / 1000])
    else lb_scl.Caption := IntToStr(dwfreq)+' Hz';
  end else lb_scl.Caption := '--- Hz';
  StatusBar.Panels[0].text := 'SET SCL: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_sharClick(Sender: TObject);
var sTmp : String;
    dwErr : DWORD;
begin
  sTmp := ed_shar.Text;
  dwErr := setshar(GetIPBytes(sTmp,1),
                   GetIPBytes(sTmp,2),
                   GetIPBytes(sTmp,3),
                   GetIPBytes(sTmp,4),
                   GetIPBytes(sTmp,5),
                   GetIPBytes(sTmp,6),1000);
  statusbar.panels[0].text := 'SET SHAR: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_subrClick(Sender: TObject);
var sTmp : String;
    dwErr : DWORD;
begin
  sTmp := ed_subr.Text;
  dwErr := setsubr(GetIPBytes(sTmp,1),
                   GetIPBytes(sTmp,2),
                   GetIPBytes(sTmp,3),
                   GetIPBytes(sTmp,4),1000);
  statusbar.panels[0].text := 'SET SUBR: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_tcpportClick(Sender: TObject);
var iPort : Word;
    dwErr : DWORD;
begin
  iPort := StrToIntDef(ed_tcpport.Text,5000);
  ed_tcpport.Text := IntToStr(iPort);
  dwErr := settcpport(iPort,1000);
  statusbar.panels[0].text := 'SET TCP PORT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_udpportClick(Sender: TObject);
var iPort : Word;
    dwErr : DWORD;
begin
  iPort := StrToIntDef(ed_udpport.Text,3000);
  ed_udpport.Text := IntToStr(iPort);
  dwErr := setudpport(iPort,1000);
  statusbar.panels[0].text := 'SET UDP PORT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_vmtcpportClick(Sender: TObject);
var iPort : Word;
    dwErr : DWORD;
begin
  iPort := StrToIntDef(ed_vmtcpport.Text,5001);
  ed_vmtcpport.Text := IntToStr(iPort);
  dwErr := setvmtcpport(iPort,1000);
  statusbar.panels[0].text := 'SET VM TCP PORT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_set_vmudpportClick(Sender: TObject);
var iPort : Word;
    dwErr : DWORD;
begin
  iPort := StrToIntDef(ed_vmudpport.Text,3001);
  ed_vmudpport.Text := IntToStr(iPort);
  dwErr := setvmudpport(iPort,1000);
  statusbar.panels[0].text := 'SET VM UDP PORT: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_vmflashClick(Sender: TObject);
var dwErr, chksum : DWORD;
    wsize : word;
begin
  if OpenDialog2.Execute then
  begin
    memoclear;
    tomemo('Select Image File:');
    tomemo(OpenDialog2.FileName);
    tomemo('Start flashing image:');
    tomemo('uploading: 0%');
    dwErr := vmloadverifycode_w(PChar(OpenDialog2.FileName), chksum, wsize,@VMFlashCallBack,1000);
    if dwErr = RET_OK then
    begin
      tomemo('Image Size: '+IntToStr(wSize));
      tomemo('CheckSum: 0x'+IntToHex(chksum,8));
      tomemo('Uploading binary file OK');
    end else tomemo('Uploading binary file failed');
    statusbar.panels[0].text := 'VM IMAGE UPDATE: '+ GetErrorString(dwErr);
  end;
end;

procedure Tfmmain.btn_vmirqClick(Sender: TObject);
var ucSize, i : WORD;
    svmdata : String;
    vmdata : Array of Byte;
    dwErr   : DWORD;
begin
  svmdata := ed_vmirq.Text;
  ucSize := length(svmdata) DIV 2;
  if ucSize = 0 then Exit;
  setlength(vmdata,ucSize);

  for i := 0 to ucSize -1 do
  begin
    vmdata[i] := StrToInt('$'+copy(svmdata,1,2));
    delete(svmdata,1,2);
  end;
  dwErr := vmirqrequest(vmdata[0],ucSize,1000);
  if dwErr = RET_OK then Memo.Lines.Add(IntToStr(ucSize)+' Byte(s) written to VM');
  StatusBar.Panels[0].text := 'VM IRQ: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.btn_vmresetClick(Sender: TObject);
begin
  statusbar.panels[0].text := 'VM RESET: '+ GetErrorString(vmreset(1000));
end;

procedure Tfmmain.btn_vmstartClick(Sender: TObject);
begin
  statusbar.panels[0].text := 'VM START: '+ GetErrorString(vmstartrequest(1000));
end;

procedure Tfmmain.btn_vmstopClick(Sender: TObject);
begin
  statusbar.panels[0].text := 'VM STOP: '+ GetErrorString(vmstoprequest(1000));
end;

procedure Tfmmain.btn_write_slvbufClick(Sender: TObject);
const ResEvent : array[0..1] of string = ('WITHOUT EVENT','WITH EVENT');
var wSize, i : WORD;
    si2cdata : String;
    i2cdata : Array of Byte;
    dwErr   : DWORD;
    ucEvent : Byte;
begin
  ucEvent := Byte(cb_int_out.Checked);
  si2cdata := ed_slave_data.Text;
  wSize := length(si2cdata) DIV 2;
  setlength(i2cdata,wSize);

  for i := 0 to wSize -1 do
  begin
    i2cdata[i] := StrToInt('$'+copy(si2cdata,1,2));
    delete(si2cdata,1,2);
  end;
  dwErr := writei2cslavebuf(i2cdata[0],wSize,ucEvent,1000);
  if dwErr = RET_OK then
  begin
    Memo.Lines.Add(IntToStr(wSize)+' Byte(s) written to Slave_Buf');
    Memo.Lines.Add(ResEvent[ucEvent]);
  end;
  StatusBar.Panels[0].text := 'WRITE I2C: '+ GetErrorString(dwErr);
end;

procedure Tfmmain.Button1Click(Sender: TObject);
begin
  Memo.lines.Clear;
end;

procedure Tfmmain.ClearMemo1Click(Sender: TObject);
begin
  Memo.Lines.Clear;
end;

procedure Tfmmain.Connect1Click(Sender: TObject);
begin
  if connected <> RET_OK then
  begin
    if connect(PAnsiChar(AnsiString(sServer)),wTCPPort) = RET_OK then
      Caption := 'CONNECTED TO '+sServer
    else Caption := 'UNABLE TO CONNECT TO '+ sServer;
  end;
end;

procedure Tfmmain.Disconnect1Click(Sender: TObject);
begin
  if connected = RET_OK then
  begin
    if disconnect = RET_OK then
      Caption := 'DISCONNECTED';
  end else Caption := 'DISCONNECTED';
end;

function TfmMain.DWORDTosIP(dwIP: DWORD): String;
begin
  Result := IntToStr(Byte(dwIP shr 24))+'.';
  Result := Result + IntToStr(Byte(dwIP shr 16))+'.';
  Result := Result + IntToStr(Byte(dwIP shr 8))+'.';
  Result := Result + IntToStr(Byte(dwIP));
end;

function TfmMain.GetIPBytes(sIP: String; iPosi: Byte): Byte;
var posi  : Byte;
    SubIP : String;
    iIP   : Byte;
begin
  SubIP := '';

  case iposi of
  1: posi := 1;
  2: posi := 5;
  3: posi := 9;
  4: posi := 13;
  5: posi := 17;
  6: posi := 21;
  else posi := 0;
  end;

  if posi > 0 then
  begin
    SubIP := Trim(Copy(sIP,Posi,3));
    if SubIP = '' then
      SubIP := '0';
    SubIP := IntToStr(StrToInt(SubIP));
    iIP   := StrToInt(SubIP);
  end else iIP := 0;
  Result := iIP;
end;

procedure Tfmmain.Exit1Click(Sender: TObject);
begin
  Close;
end;

end.
