unit UnitDllDefs;

interface
uses windows;

Const DLLName = 'lani2cvm.dll';
      RET_OK  = 0;

      CMD_WRBYTE      = $01;
      CMD_WRWORD      = $02;
      CMD_WRDWORD     = $03;
      CMD_WRBLOCK     = $04;
      CMD_RDBYTE      = $05;
      CMD_RDWORD      = $06;
      CMD_RDDWORD     = $07;
      CMD_RDBLOCK     = $08;

Type TNetConfig = record
     GAR       : DWORD;
     SUBR      : DWORD;
     IP        : DWORD;
     TCPPORT   : WORD;
     UDPPORT   : WORD;
     VMTCPPORT : WORD;
     VMUDPPORT : WORD;
     SHAR      : array[0..5] of byte;
     PHYCHECK  : Byte;
     KPALIVE   : Byte;
     VMKPALIVE : Byte;
     end;
     PTNetConfig = ^TNetConfig;

function geterrorstring(dwerr : DWORD) : PAnsiChar; stdcall; external DLLName;
function initnetiic(pIRQCallBack : pointer; pSlaveCallback : pointer;
                    pVMCallback : pointer) : DWORD; stdcall; external DLLName;
function connect(shost : PAnsiChar; wport : word) : DWORD; stdcall; external DLLName;
function disconnect : DWORD; stdcall; external DLLName;
function connected : DWORD; stdcall; external DLLName;
//------------------------------------------------------------------------------------------------------------------------
function writei2c(ucSlvAdr : Byte; const pi2cdata; wSize: WORD;
                  dwTimeOut : DWORD): DWORD; stdcall; external DLLName;
function readi2c(ucSlvAdr : Byte; var pi2cdata; var wSize : WORD;
                 dwTimeOut : DWORD): DWORD; stdcall; external DLLName;
function scani2c(var pScandata; var ucSize : Byte;
                 dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setscl(dwfreq : DWORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function getscl(var dwfreq : DWORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setirq(var ucIRQMode : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function getirq(var ucIRQMode : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function wrdi2c(ucSlvAdr : Byte; const pWRData; wWRSize : WORD;
                var pRDData; var wRDSize : WORD;
                dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function writei2cslavebuf(const pi2cdata; wSize : WORD; ucEvent : Byte;
                          dwTimeOut : DWORD): DWORD; stdcall; stdcall; external DLLName;
function seti2cslvaddr(var ucslvadr : byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function chkslvaddr(ucSlvAddr : Byte; var ucConnected : Byte; dwTimeOut : DWORD): DWORD; stdcall; external DLLName;
//------------------------------------------------------------------------------------------------------------------------
function setgar(ucVal1, ucVal2, ucVal3, ucVal4 : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setsubr(ucVal1, ucVal2, ucVal3, ucVal4 : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setshar(ucVal1, ucVal2, ucVal3, ucVal4, ucVal5, ucVal6 : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setip(ucVal1, ucVal2, ucVal3, ucVal4 : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function settcpport(wPort : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setudpport(wPort : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setvmtcpport(wPort : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setvmudpport(wPort : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setkeepalive(ucKPAlive : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setvmkeepalive(ucKPAlive : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setphycheck(ucPhyCheck : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function loadfactoryconfig(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function reinit(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function setmemprotect(ucProtect : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function getmemprotect(Var ucProtect : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;

//------------------------------------------------------------------------------------------------------------------------
function setmode(var ucmode, ucslvadr : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function getnetconfig(var pNetConfig; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memwr8bit(wAddr : WORD; ucVal : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memwr16bit(wAddr : WORD; wVal : WORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memwr32bit(wAddr : WORD; dwVal : DWORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memwrblock(wAddr : WORD; const pmemdata; wSize : WORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memrd8bit(wAddr : WORD; var ucVal : Byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memrd16bit(wAddr : WORD; var wVal : WORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memrd32bit(wAddr : WORD; var dwVal : DWORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function memrdblock(wAddr : WORD; var pmemdata; var wSize : WORD; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function savesettings(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function resetsettings(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function getversion(var wVersion : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;

function vmstartrequest(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmstoprequest(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmgetstate(var state : byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmirqrequest(const pvmdata; ucSize : Byte; dwTimeOut : DWORD): DWORD; stdcall; external DLLName;
function vmirqresult(var ucIRQResult : byte; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmreset(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmcodeloaded(dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmloadcode_a(pImage : PAnsiChar; Var dwImageChkSum : DWORD;
                         Var wImageSize : WORD;
                         pVMFlashCallBack : pointer;
                         dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmloadcode_w(pImage : PChar; Var dwImageChkSum : DWORD;
                         Var wImageSize : WORD;
                         pVMFlashCallBack : pointer;
                         dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmverifycode(ChkSum : DWORD; wSize : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmloadverifycode_a(pImage : PAnsiChar; Var dwImageChkSum : DWORD;
                               Var wImageSize : WORD;
                               pVMFlashCallBack : pointer;
                               dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmloadverifycode_w(pImage : PChar; Var dwImageChkSum : DWORD;
                               Var wImageSize : WORD;
                               pVMFlashCallBack : pointer;
                               dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmloadfromeep(wAddr : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmloadtoeep_a(pImage : PAnsiChar; wAddr : WORD; ucPageSize : Byte;
                       pVMFlashCallBack : pointer;
                       dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmloadtoeep_w(pImage : PChar; wAddr : WORD; ucPageSize : Byte;
                       pVMFlashCallBack : pointer;
                       dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmsetparam(ucLoad : Byte; wAddr : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;
function vmgetparam(var ucLoad : Byte; var wAddr : Word; dwTimeOut : DWORD) : DWORD; stdcall; external DLLName;


implementation

end.
